#include <cstdlib>
#include <iostream>
#include <string>

#include "serial.hpp"
#include "brick.hpp"
#include "sound.hpp"
#include "motor.hpp"
#include "sonar.hpp"
#include "sensor.hpp"

Serial bluetooth;
Sonar sonar = Sonar(0,&bluetooth);   //ultrazvuni senzor je na portu 1
Sensor touch = Sensor(1,&bluetooth); //tipkalo je na portu 2
Brick nxt = (&bluetooth);
Sound speaker = (&bluetooth);

Motor motorA = Motor(0,&bluetooth);
Motor motorB = Motor(1,&bluetooth);
Motor motorC = Motor(2,&bluetooth);//Motor C na portu 3
Sound zvuk;

using namespace std;
int main(int argc, char *argv[]){
    FILE *fp, *fp1, *fp2;

    int brz;
    int naredba; //upravljanje robotom
    int j,k,l; //zastavice za datoteke
    int i,x,y; //zastavica za naredbe

    int distance,tipkalo;

    if(bluetooth.connect("COM6")){//Spaja se na NXT kroz com port 9
       cout << "Veza OK!" << endl;
       nxt.set_name("LEGO"); //Set the brickname to LEGO
       cout << "Firmware verzija: " << nxt.firmware_version() << endl; 
       
       touch.type_and_mode(TOUCH,BOOL_MODE); //inicijaliziranje tipkala
       sonar.setup(); //inicijaliziranje ultrazvucnog senzora
       //inicijalizacija zastavica i vrijabli
       brz=35;
       naredba=13;
       i=12;
       j=0;
       k=0;
       l=0;
       distance=0;
       tipkalo=0;
       x=1;
       y=1;
       
      // cout << "Postavite zeljenu brzinu!" << endl;
      // cin >> brz;
       
       while (naredba != 1){ 
            Sleep(10);
            //ucitavanje naredbe kroz datoteku "upravljanje.txt"
            if ((fp = fopen("upravljanje.txt", "r+")) !=NULL){  //kreiranje datoteke
                j=1;
            }
            
            if(j){
               naredba=fgetc(fp);
               //fputc(100,fp1);
               fclose(fp);  //zatvori datoteku  
               j=0;
            } 
            
            //upisivanje udaljenosti u datoteku "udaljenost.txt"
            if ((fp1 = fopen("udaljenost.txt", "w"))!=NULL){//kreiranje datoteke
                k=1;
                
            }            
            
            if(k){
                fputc(distance,fp1); //upisi podatak o udaljenosti u datoteku
                fclose(fp1);  //zatvori datoteku
                k=0;
            }            
            
            //upisivanje vrijednosti tipkala u datoteku "tipkalo.txt"
            if ((fp1 = fopen("tipkalo.txt", "w")) !=NULL){  //kreiranje datoteke
                l=1;
            }  
                    
            if(l){
                tipkalo=touch.read();
                            
                fputc(tipkalo,fp1); //upisi vrijednost tipkala
                fclose(fp1);  //zatvori datoteku
                l=0;
            }
            
            // upravljaki i senzorski odlomci:
            
            distance=sonar.distance(); //ocitavanje udaljenosti
            
//            if (distance < 35){
//                motorB.stop();
//                motorC.stop();
//            }
                
            if (naredba == 8 && naredba!=i){ //oba motora naprijed
                    motorC.on(brz); 
                    motorB.on(brz);
                    i=naredba;
            }
           
            if (naredba == 5 && naredba!=i){ //oba motora zaustavljena
                    motorC.stop(); 
                    motorB.stop();
                    i=naredba;
            }
                
            if (naredba == 2 && naredba!=i){ //oba motora nazad
                      motorC.on(-brz); 
                      motorB.on(-brz);
                      i=naredba;
                      
            } 
                  
            if (naredba == 4 && naredba!=i){ //kretanje u lijevo
                      motorC.on(-brz/6);
                      motorB.on(brz/6);
                      i=naredba;
            }
                      
            if (naredba == 6 && naredba!=i){ //kretanje u desno
                      motorC.on(brz/6);
                      motorB.on(-brz/6);
                      i=naredba;
            }
                       
            if (naredba == 0 && naredba!=i){ //zvuni signal
                      speaker.beep(200);
                      i=naredba;
   
            }
           
            if (naredba == 7 && naredba!=i){ //otvaranje klijeta
                       if(x){
                           motorA.reset_rotation();
                           motorA.on(10,45);
                           i=naredba;
                           x=0;
                           y=1;
                        }
            }
           
            if (naredba == 9 && naredba!=i){ //zatvaranje klijeta
                      if(y){
                           motorA.reset_rotation();
                           motorA.on(-10,45);
                           i=naredba;
                           y=0;
                           x=1;
                      }
            }
                              
       }                      
       
       bluetooth.disconnect();//Odspaja se bluetooth
    }
    else{
        cout << "Bluetooth veza nije uspostavljena!" << endl;
   }
    Sleep(200);
    exit(1);
}

